package com.brilliance.isc.funds.common.controller;

import com.brilliance.isc.common.api.trndoc.controller.AbstractTrndocController;
import com.brilliance.isc.common.api.trndoc.vo.TrndocRequest;
import com.brilliance.isc.common.api.trndoc.vo.TrndocResponse;
import com.brilliance.isc.vo.ResponseSet;
import com.brilliance.isc.vo.funds.FtdBizAmdInfoVo;
import com.brilliance.isc.vo.funds.FtdBizInfoVo;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;
import java.util.Map;

/**
 * 报文面函组件
 */
@RestController
@RequestMapping("/ftd")
public class FtdTrndocController extends AbstractTrndocController<FtdBizInfoVo, FtdBizAmdInfoVo> {
    /**
     * 面函报文试算入口
     *
     * @param trndoc
     * @return
     */

    @RequestMapping("/docpan/assertTrndoc")
    @Override
    public ResponseSet<TrndocResponse> assertTrndoc(@RequestBody TrndocRequest<FtdBizInfoVo, FtdBizAmdInfoVo> trndoc) {
        return super.assertTrndoc(trndoc);
    }

    /**
     * 面函报文预览功能
     *
     * @param paramMap
     * @return
     * @throws IOException
     */

    @RequestMapping("/docpan/showDOCS")
    @Override
    public ResponseSet<TrndocResponse> showDOCS(@RequestBody Map<String, Object> paramMap) throws IOException {
        return super.showDOCS(paramMap);
    }
}
