package com.brilliance.isc.funds.fttfcm.register.settle;

import com.brilliance.isc.bo.model.Ftdgrp;
import com.brilliance.isc.common.cbsmod.service.XrtmodService;
import com.brilliance.isc.common.glemod.service.GlemodService;
import com.brilliance.isc.common.register.settle.DefaultSettleRegister;
import com.brilliance.isc.common.register.settle.ISettleRegister;
import com.brilliance.isc.common.setglg.service.SetglgService;
import com.brilliance.isc.common.setglg.vo.SetglgVo;
import com.brilliance.isc.common.setmod.service.SetmodService;
import com.brilliance.isc.common.setmod.vo.SetmodVo;
import com.brilliance.isc.common.vo.PtsptaVo;
import com.brilliance.isc.funds.common.component.FtToolComponent;
import com.brilliance.isc.vo.funds.FtdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.Decimals;
import com.brilliance.mda.runtime.mda.util.Formats;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.brilliance.isc.common.component.PtsptaToolComponent;

import javax.annotation.Resource;
import java.math.BigDecimal;

import static com.brilliance.mda.runtime.mda.Constants.*;
import static com.brilliance.mda.runtime.mda.Constants.CR;

@Component("fttfcm.settleRegister")
public class FttfcmSettleRegister implements ISettleRegister {

    @Autowired
    private SetmodService setmodService;
    @Autowired
    private SetglgService setglgService;
    @Autowired
    private DefaultSettleRegister defaultSettleRegister;
    @Autowired
    private GlemodService glemodService;


    @Resource
    private XrtmodService xrtmodService;

    @Resource
    private FtToolComponent ftToolComponent;

    @Resource
    private PtsptaToolComponent ptsptaToolComponent;

    @Override
    public void registerSettlement(SetmodVo setmodVo) {
        transRegister(setmodVo);
        defaultSettleRegister.registerSettlement(setmodVo);
    }

    private void transRegister(SetmodVo setmodVo) {
        FtdBizInfoVo rec = (FtdBizInfoVo) setmodVo.getRec();

        //Ftdgrp ftdgrp = ftToolComponent.getFtdgrpByInr(rec.getObjinr());
        PtsptaVo tri = ptsptaToolComponent.getPtsFromListByRol(setmodVo.getPtsList(), "TRI");
        PtsptaVo tro = ptsptaToolComponent.getPtsFromListByRol(setmodVo.getPtsList(), "TRO");

        String maxCur=NULLSTR;
        BigDecimal maxAmt = BigDecimal.ZERO;
        String opn1Cur=NULLSTR;
        BigDecimal opn1Amt = BigDecimal.ZERO;


        if (setmodVo.getCbsMap().get("MAX") != null) {
            maxAmt = setmodVo.getCbsMap().get("MAX").getAmt();
            maxCur= setmodVo.getCbsMap().get("MAX").getCur();
        }

        if (setmodVo.getCbsMap().get("OPN1") != null) {
            opn1Amt= setmodVo.getCbsMap().get("OPN1").getAmt();
            opn1Cur= setmodVo.getCbsMap().get("OPN1").getCur();
        }

        setmodVo.setDoccur(maxCur);
        setmodVo.setDocamt(maxAmt);

        SetglgVo setglg = setmodVo.getSetglg();

        setglgService.setglgClrAmount ( setmodVo.getSetglg(),"TRN" );

        String acctyp = NULLSTR;
        String acc = NULLSTR;
        String cdtKey = NULLSTR;
        String dbtKey = NULLSTR;
        switch( rec.getFttyp() )
        {
            // 资金拆出
            case "LO":
                acctyp = "";
                acc = "";

                if( MdaUtils.compareTo(rec.getBnktyp(),"9") == 0 )
                {
                    acctyp = "FL-FOG";
                }
                else
                {
                    acctyp = "FL-DO" + rec.getBnktyp();
                }
                //贷记
                cdtKey = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"TRN", "TRI", setmodVo.getDoccur(), maxAmt.negate(), "", "PAC", "C", "", "" );
                acc = glemodService.getAvailAcc ( acctyp,setmodVo.getDoccur(), tri.getPts().getPtyinr(),  maxAmt );

                dbtKey = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"TRN", "TRI",setmodVo.getDoccur(),maxAmt, "", "FLD", "C", acc, "" );
                setmodVo.setFeeclirol( "TRI" );
                // 定存存出
                break;
            case "DO":
                acctyp = "";
                acc = "";
                /**
                 if FTDGRP\\TRI.IsDemestic then
                 $acctyp = "DB-CLR"
                 else
                 $acctyp = "DB-FOG"
                 endif

                 **/
                if( MdaUtils.compareTo(rec.getBnktyp(),"9") == 0 )
                {
                    acctyp = "DB-FOG";
                }
                else
                {
                    acctyp = "DB-CLR";
                }
                cdtKey = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"TRN", "TRI",setmodVo.getDoccur(),maxAmt.negate(), "", "PAC", "C", "", "" );
                acc =glemodService.getAvailAcc ( acctyp, setmodVo.getDoccur(),tri.getPts().getPtyinr(),  maxAmt );
                /**
                 $DbtKey = SETMOD\\SETGLG.SetglgAddAmount ( "TRN", "TRI", SETMOD\\DOCCUR, FTDGRP\\CBS\\MAX\\AMT, "", "DBD", "A", $acc, "" )

                 **/
                dbtKey = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"TRN", "TRI", setmodVo.getDoccur(),maxAmt, "", "DBD", "C", acc, "" );
                setmodVo.setFeeclirol ( "TRI" );
                // 资金拆入
                break;
            case "LI":
                acctyp = "";
                acc = "";
                /**
                 if FTDGRP\\TRO.IsDemestic then
                 $acctyp = "FB-DOM"
                 else
                 $acctyp = "FB-FOG"
                 endif

                 **/
                if( MdaUtils.compareTo(rec.getBnktyp(),"9") == 0 )
                {
                    acctyp = "FB-FOG";
                }
                else
                {
                    acctyp = "FB-DO" + rec.getBnktyp();
                }
                acc = glemodService.getAvailAcc ( acctyp, setmodVo.getDoccur(),tro.getPts().getPtyinr(),  maxAmt.negate() );
                //贷记
                /**
                 $CdtKey = SETMOD\\SETGLG.SetglgAddAmount ( "TRN", "TRO", SETMOD\\DOCCUR, -FTDGRP\\CBS\\MAX\\AMT, "", "FBC", "A", $acc, "" )

                 **/
                cdtKey = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"TRN", "TRO", setmodVo.getDoccur(),maxAmt.negate(), "", "FBC", "C", acc, "" );
                //借记
                dbtKey =setglgService.setglgAddAmount ( setmodVo.getSetglg(),"TRN", "TRO",setmodVo.getDoccur(), maxAmt, "", "FTD", "C", "", "" );
                setmodVo.setFeeclirol ( "TRO" );
                // 定存吸存
                break;
            case "DI":
                acctyp = "";
                acc = "";
                /**
                 if FTDGRP\\TRO.IsDemestic then
                 $acctyp = "DB-CLR"
                 else
                 $acctyp = "DB-FOG"
                 endif

                 **/
                if( MdaUtils.compareTo(rec.getBnktyp(),"9") == 0 )
                {
                    acctyp = "VO-FOG";
                }
                else
                {
                    acctyp = "VO-BO" + rec.getBnktyp();
                }
                acc = glemodService.getAvailAcc ( acctyp, setmodVo.getDoccur(), tro.getPts().getPtyinr(),  maxAmt.negate() );
                /**
                 $CdtKey = SETMOD\\SETGLG.SetglgAddAmount ( "TRN", "TRO", SETMOD\\DOCCUR, -FTDGRP\\CBS\\MAX\\AMT, "", "VOC", "A", $acc, "" )

                 **/
                cdtKey = setglgService.setglgAddAmount ( setmodVo.getSetglg(),"TRN", "TRO",setmodVo.getDoccur(), maxAmt.negate(), "", "VOC", "C", acc, "" );
                dbtKey =setglgService.setglgAddAmount (setmodVo.getSetglg(), "TRN", "TRO",setmodVo.getDoccur(), maxAmt, "", "FTD", "C", "", "" );
                setmodVo.setFeeclirol ( "TRO" );
                break;
        }
        setmodService.setglgAllValDat ( setmodVo, rec.getValdat(), "D" );
    }



}
