package com.brilliance.isc.funds.fttfmt.register.settle;

import com.brilliance.isc.bo.model.Ftdgrp;
import com.brilliance.isc.common.cbsmod.service.XrtmodService;
import com.brilliance.isc.common.glemod.service.GlemodService;
import com.brilliance.isc.common.register.settle.DefaultSettleRegister;
import com.brilliance.isc.common.register.settle.ISettleRegister;
import com.brilliance.isc.common.setglg.service.SetglgService;
import com.brilliance.isc.common.setglg.vo.SetglgVo;
import com.brilliance.isc.common.setmod.service.SetmodService;
import com.brilliance.isc.common.setmod.vo.SetmodVo;
import com.brilliance.isc.funds.common.component.FtToolComponent;
import com.brilliance.isc.vo.funds.FtdBizInfoVo;
import com.brilliance.mda.runtime.mda.util.MdaUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import com.brilliance.isc.common.component.PtsptaToolComponent;

import javax.annotation.Resource;
import java.math.BigDecimal;

import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;

@Component("fttfmt.settleRegister")
public class FttfmtSettleRegister implements ISettleRegister {

    @Autowired
    private SetmodService setmodService;
    @Autowired
    private SetglgService setglgService;
    @Autowired
    private DefaultSettleRegister defaultSettleRegister;
    @Autowired
    private GlemodService glemodService;
    @Resource
    private XrtmodService xrtmodService;
    @Resource
    private FtToolComponent ftToolComponent;
    @Resource
    private PtsptaToolComponent ptsptaToolComponent;

    @Override
    public void registerSettlement(SetmodVo setmodVo) {
        transRegister(setmodVo);
        defaultSettleRegister.registerSettlement(setmodVo);
    }

    private void transRegister(SetmodVo setmodVo) {
        setmodVo.setDocamt(setmodVo.getCbsMap().get("MAX").getAmt());
        setmodVo.setDoccur(setmodVo.getCbsMap().get("MAX").getCur());
        SetglgVo setglgVo = setmodVo.getSetglg();
        setglgService.setglgClrAmount(setglgVo, "TRN");
        String acctyp1 = "";
        // LI资金拆入   LO资金拆出      DI 定存吸存     DO定存存出       PT头寸调拨
        String dacc = NULLSTR;
        String dbtKey = NULLSTR;
        String dsp = NULLSTR;
        String acc = NULLSTR;
        String cdtKey = NULLSTR;
        String cdtKey2 = NULLSTR;
        String acc1 = NULLSTR;
        String dbtKey2 = NULLSTR;
         FtdBizInfoVo rec = (FtdBizInfoVo) setmodVo.getRec();
         Ftdgrp ftdgrp = ftToolComponent.getFtdgrpByInr(rec.getObjinr());
        switch (ftdgrp.getRec().getFttyp()){
            case "DO":
            case "LO":
                dacc = glemodService.getAvailAcc("FT-FXR",setmodVo.getDoccur(),"",ftdgrp.getCbs().getMax().getAmt().negate());
            //借记
                dbtKey = setglgService.setglgAddAmount(setglgVo,"TRN","TRI",
                        setmodVo.getDoccur(),setmodVo.getSetamt(),"","FTD","C",dacc,"");
                if (MdaUtils.compareTo(ftdgrp.getRec().getFttyp(),"LO")==0){
                    if (MdaUtils.compareTo(ftdgrp.getRec().getBnktyp(),"9") == 0){
                        acctyp1 = "FL-FOG";
                    }else {
                        acctyp1 = "FL-DO" + ftdgrp.getRec().getBnktyp();
                    }
                    dsp = "FLC";

                }else {
                    if (MdaUtils.compareTo(ftdgrp.getRec().getBnktyp(),"9") == 0){
                        acctyp1 = "DB-FOG";
                    }else {
                        acctyp1 = "DB-CLR";
                    }
                    dsp = "DBC";
                }

                if (MdaUtils.compareTo(ftdgrp.getRec().getFttyp(),"LO") == 0){
                    acc = glemodService.getAvailAcc(acctyp1,setmodVo.getDoccur(),"",ftdgrp.getCbs().getMax().getAmt().negate());
                }else {
                    acc = glemodService.getAvailAcc(acctyp1,setmodVo.getDoccur(),ftdgrp.getTri().getPts().getPtyinr(),ftdgrp.getCbs().getMax().getAmt().negate());
                }
            //贷记
            //贷记利息收入    ftdgrp.getCbs().getIns().getAmt() => this.getIntamt().negate()
                cdtKey2 = setglgService.setglgAddAmount(setglgVo,"TRN","OWN",setmodVo.getDoccur(),
                                                        ftdgrp.getCbs().getIns().getAmt().negate(), "","FIC","C","","");
                setmodVo.setFeeclirol("TRI");
                break;

            case "DI":
            case "LI":
                if (MdaUtils.compareTo(ftdgrp.getRec().getFttyp(),"DI") == 0){
                    if (MdaUtils.compareTo(ftdgrp.getRec().getBnktyp(),"9") == 0){
                        acctyp1 = "VO-FOG";
                    }else {
                        acctyp1 = "VO-BO" + ftdgrp.getRec().getBnktyp();
                    }
                    dsp = "VOD";
                }else {
                    if (MdaUtils.compareTo(ftdgrp.getRec().getBnktyp(),"9") == 0){
                        acctyp1 = "FB-FOG";
                    }else {
                        acctyp1 = "FB-DO" + ftdgrp.getRec().getBnktyp();
                    }
                    dsp = "FBD";
                }
                acc1 = glemodService.getAvailAcc(acctyp1,setmodVo.getDoccur(),"",ftdgrp.getCbs().getMax().getAmt().negate());
                dbtKey = setglgService.setglgAddAmount(setglgVo,"TRN","OWN",setmodVo.getDoccur(),ftdgrp.getCbs().getMax().getAmt(),"",
                                                        dsp,"C",acc1,"");
                // ftdgrp.getCbs().getIns().getAmt() => getIntamt()
                dbtKey2 = setglgService.setglgAddAmount(setglgVo,"TRN","TRO",setmodVo.getDoccur(),
                                                        ftdgrp.getCbs().getIns().getAmt(), "","FID","C","","");
                cdtKey = setglgService.setglgAddAmount(setglgVo,"TRN","TRO",setmodVo.getDoccur(),setmodVo.getSetamt().negate(),"",
                                                           "PAC","C","","");
                setmodVo.setFeeclirol("TRO");
                break;
        }
    }
}
