package com.brilliance.isc.funds.transfer.transaction;


import com.brilliance.isc.funds.bo.funds.FttfcmStoreBo;
import com.brilliance.isc.funds.vo.funds.FttfcmStoreVo;
import com.brilliance.isc.transfer.IBaseStructMapper;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.Mappings;
import org.mapstruct.factory.Mappers;

@Mapper(componentModel = "spring")
public interface FttfcmStructMapper extends IBaseStructMapper<FttfcmStoreBo, FttfcmStoreVo> {
    /**
     * 此行语句一定要写，StructMapper需要
     */
    FttfcmStructMapper INSTANCE = Mappers.getMapper(FttfcmStructMapper.class);

    /**
     * Vo转为Bo
     *
     * @param vo
     * @return 返回业务Bo
     */
    @Override
    FttfcmStoreBo voTransferToBo(FttfcmStoreVo vo);

    /**
     * Vo追加更新至Bo
     *
     * @param vo
     * @param bo
     */
    @Override
    @Mappings({

    })
    void voUpdateToBo(FttfcmStoreVo vo, @MappingTarget FttfcmStoreBo bo);

    /**
     * Bo转为Vo
     *
     * @param bo
     * @return 返回Vo
     */
    @Override
    FttfcmStoreVo boTransferToVo(FttfcmStoreBo bo);

    /**
     * bo追加更新至Bo
     *
     * @param bo
     * @param vo
     */
    @Override
    void boUpdateToVo(FttfcmStoreBo bo, @MappingTarget FttfcmStoreVo vo);
}
