package com.brilliance.isc.funds.transfer.transaction;

import com.brilliance.isc.funds.bo.funds.FxtlcmStoreBo;
import com.brilliance.isc.funds.bo.funds.FxtlopStoreBo;
import com.brilliance.isc.funds.vo.funds.FxtlcmStoreVo;
import com.brilliance.isc.funds.vo.funds.FxtlopStoreVo;
import com.brilliance.isc.transfer.IBaseStructMapper;
import com.sun.javaws.jnl.RContentDesc;
import org.mapstruct.Mapper;
import org.mapstruct.MappingTarget;
import org.mapstruct.Mappings;
import org.mapstruct.factory.Mappers;

/**
 * @program: isc-funds
 * @ClassName: FxtlcmStructMapper
 * @description: 结售汇平盘确认转换Fxtlcm Bo、Vo之间的转换处理类。如果有很复杂的函数，则可以用适配器模式重写
 * @author: Lenovo
 * @create: 2024-10-14 11:44
 */
@Mapper(componentModel = "spring")
public interface FxtlcmStructMapper extends IBaseStructMapper<FxtlcmStoreBo, FxtlcmStoreVo> {
    /**
     * 此行语句一定要写，StructMapper需要
     */
    FxtlcmStructMapper INSTANCE = Mappers.getMapper(FxtlcmStructMapper.class);

    /**
     * Vo转为Bo
     *
     * @param vo
     * @return 返回业务Bo
     */
    @Override
    FxtlcmStoreBo voTransferToBo(FxtlcmStoreVo vo);

    /**
     * Vo追加更新至Bo
     *
     * @param vo
     * @param bo
     */
    @Override
    @Mappings({

    })
    void voUpdateToBo(FxtlcmStoreVo vo, @MappingTarget FxtlcmStoreBo bo);

    /**
     * Bo转为Vo
     *
     * @param bo
     * @return 返回Vo
     */
    @Override
    FxtlcmStoreVo boTransferToVo(FxtlcmStoreBo bo);

    /**
     * bo追加更新至Bo
     *
     * @param bo
     * @param vo
     */
    @Override
    void boUpdateToVo(FxtlcmStoreBo bo, @MappingTarget FxtlcmStoreVo vo);
}
