package com.brilliance.isc.funds.vo.funds;

import com.brilliance.isc.bo.model.Fxdgrp;
import com.brilliance.isc.bo.model.Fxtp;
import com.brilliance.isc.common.transaction.vo.BaseTransactionVo;
import com.brilliance.isc.common.vo.PtsptaVo;
import com.brilliance.mda.runtime.mda.util.Decimals;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import lombok.Data;

import java.math.BigDecimal;

import static com.brilliance.mda.runtime.mda.Constants.NULLSTR;

/**
 * @program: isc-funds
 * @ClassName: FxtfcmStoreVo
 * @description: 结售汇平盘确认bo
 * @author: xiaotong
 * @create: 2024-10-11 11:42
 */
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class FxtfcnStoreVo extends BaseTransactionVo {
    //Cancel Amount
    private BigDecimal canamt = Decimals.ZERO_SCALE2;
    //Cancel Currency
    private  String cancur= NULLSTR;
    //Old Account Bank Inr
    private  String oldactinr= NULLSTR;
    //Related Currency
    private  String relcur= NULLSTR;
    //Related Amount
    private  BigDecimal relamt = Decimals.ZERO_SCALE2;
    //Reference
    private  String f21= NULLSTR;
    //APLACC's Account
    private  String acc2= NULLSTR;
    //OWNACC's Account
    private  String acc1= NULLSTR;
    //Cancel Amount
    private  BigDecimal canamtuse = Decimals.ZERO_SCALE2;
    //Cancel Currency
    private  String cancuruse= NULLSTR;

    private Fxdgrp fxdgrp;

    //private Fxtmod fxtmod;

    private Fxtp fxtp;

    private PtsptaVo aplacc;

    @Override
    public void reset() {
        super.reset();
        if (fxdgrp == null) {
            fxdgrp = new Fxdgrp();
        }
        fxdgrp.reset();

        if (fxtp == null) {
            fxtp = new Fxtp();
        }
        fxtp.reset();
    }
}
